//******************************************************************************
// 
//                 UNIT ULOGO (-)
// 
//******************************************************************************
// Project:        ECF99 verso para LINUX
// File:           uLogo.pas
// Directory:      C:\projetos\cupom\source\
// Function:       ..
// Description:    ..
// Author:         Charles Alves
// Environment:    Kylix 1 Open Edition, Celerom 333, 64MB, Linux Mandrake 8
// Compiled state: Kylix Compiled Unit: uLogo.dcu
// Resources:      Linxu API
// Notes:          ..
// Revisions:      
// 
// 01.00.00 03/10/2001
// 
//******************************************************************************

unit uLogo;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QComCtrls, QExtCtrls, QMask, QButtons, Libc;



type
  TfrmLogo = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    BitBtn1: TBitBtn;
    Limpar: TBitBtn;
    Label3: TLabel;
    Panel2: TPanel;
    Image2: TImage;
    BitBtn2: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure LimparClick(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormActivate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const largura = 10;
const altura  = 20;

var
  frmLogo: TfrmLogo;
  Grade: array[1..100] of char;
  Pintar, Apagar: Boolean;
  ucol, ulin: integer;

implementation

uses uPrincipal;

{$R *.xfm}

procedure TfrmLogo.BitBtn1Click(Sender: TObject);
var
   i: integer;
begin
   if bitbtn1.Caption = 'Grade' then begin
      image1.Canvas.pen.Color:=clSilver;
      bitbtn1.Caption := 'Sem Grade';
   end
   else begin
      image1.Canvas.pen.Color:=clWhite;
      bitbtn1.Caption := 'Grade';
   end;
   i:=10;
   while i < 1000 do begin
      image1.Canvas.MoveTo(i,0);
      image1.Canvas.LineTo(i,160);
      i:=i+10;
   end;
   i:=20;
   while i < 160 do begin
      image1.Canvas.moveto(0,i);
      image1.Canvas.lineto(1000,i);
      i:=i+20;
   end;
end;

procedure TfrmLogo.LimparClick(Sender: TObject);
var i: integer;
begin
   for i:=1 to 100 do
      grade[i]:=#0;
   image1.Canvas.pen.Color:=clWhite;
   image1.Canvas.Brush.Color:=clWhite;
   image1.Canvas.FillRect(Rect(0,0,Image1.Width,Image1.Height));
   image2.Canvas.pen.Color:=clWhite;
   image2.Canvas.Brush.Color:=clWhite;
   image2.Canvas.FillRect(Rect(0,0,Image2.Width,Image2.Height));
end;

procedure TfrmLogo.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     Pintar:=True;
     if button = mbLeft then
        Apagar:=False
        else
            Apagar:=True;
     ucol:=-1;
     ulin:=-1;
     Image1MouseMove(Sender,Shift,X,Y);
end;

procedure TfrmLogo.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var col, lin: Byte;
    bit, aux: integer;
begin
     if Pintar then
     begin
          col:= (x div largura);
          lin:= (y div altura);
          if ((col <> ucol) or (lin <> ulin)) and (lin < 8) then
          begin
               ucol:=col;
               ulin:=lin;
               bit :=1 shl (7-lin);
               aux := Ord (grade [col+1]);
               if apagar then
               begin
                    image1.Canvas.Brush.Color := clWhite;
                    image2.Canvas.Brush.Color := clWhite;
                    aux := aux and (not bit);
                    image1.Canvas.FillRect(Rect(col*largura+1, lin*altura+1, col*largura+largura-1, lin*altura+altura-1));
                    image2.Canvas.FillRect(Rect(col*largura div 5, lin*altura div 5, (col*largura+largura) div 5, (lin*altura +altura) div 5));
               end
                  else
                  begin
                       image1.Canvas.Brush.Color := clNavy;
                       image1.Canvas.pen.Color:=clblack;
                       image2.Canvas.Brush.Color := clNavy;
                       image2.Canvas.pen.Color:=clblack;
                       aux := aux or bit;
                       image1.Canvas.Ellipse(Rect(col*largura+1, lin*altura+1, col*largura+largura-1, lin*altura+altura-3));
                       image2.Canvas.Ellipse(Rect(col*largura div 5, lin*altura div 5, (col*largura+largura) div 5, (lin*altura +altura) div 5));
                  end;
               grade [col+1] := Chr (aux);
          end;
     end;
end;

procedure TfrmLogo.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     Pintar:=False;
end;

procedure TfrmLogo.FormActivate(Sender: TObject);
begin
     Limpar.Click;
end;

procedure TfrmLogo.BitBtn2Click(Sender: TObject);
var auxLogo:string;
    i: integer;
begin
     auxLogo:='';
     for i:=1 to 100 do
        if Grade[i] = #0 then
           auxLogo:=AuxLogo+' '
        else
           auxLogo:=auxLogo+Grade[i];
     for i := 1 to Length(auxlogo) do
         frmPrincipal.edFormatoLogo.text := frmPrincipal.edFormatoLogo.text + IntToHex(ord(auxlogo[i]),2);
     close;
end;

initialization
   for ulin:=1 to 100 do
       grade[ulin]:=#0;
end.

//******************************************************************************
//*                          End of File uLogo.pas
//******************************************************************************
